"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var AccordionDemo = (function () {
    function AccordionDemo() {
        this.oneAtATime = true;
        this.duration = 250;
        this.firstOpen = true;
        this.firstDisabled = false;
        this.lastOpen = false;
        this.contentItems = ['Item 1', 'Item 2', 'Item 3'];
        this.accordionItems = [
            {
                heading: 'Custom Object Header - 1',
                content: 'Custom Object Body - 1'
            },
            {
                heading: 'Custom Object Header - 2',
                content: 'Custom Object Body - 2'
            }
        ];
        this.accordionAttributes = [
            new demoUtilities_1.Attribute('closeOthers', 'boolean', 'true', 'Only be able to have one accordion item opened at once'),
            new demoUtilities_1.Attribute('duration', 'number', '250', 'Duration of the collapse animations')
        ];
        this.accordionAttributesColumns = demoUtilities_1.AttributeColumns;
        this.accordionAttributesSort = demoUtilities_1.AttributesDefaultSort;
        this.accordionItemAttributes = [
            new demoUtilities_1.Attribute('disabled', 'boolean', 'false', 'Disable accordion item from opening on click and display as greyed out'),
            new demoUtilities_1.Attribute('open', 'boolean', 'false', 'The status of the accordion item showing content'),
            new demoUtilities_1.Attribute('heading', 'string', 'null', 'The clickable heading of the content of your accordion item')
        ];
        this.accordionItemAttributesColumns = demoUtilities_1.AttributeColumns;
        this.accordionItemAttributesSort = demoUtilities_1.AttributesDefaultSort;
    }
    AccordionDemo.prototype.addContentItem = function () {
        this.contentItems.push('New Item ' + (this.contentItems.length + 1));
    };
    AccordionDemo.prototype.addAccordionItem = function () {
        this.accordionItems.push({
            heading: 'Custom Object Header - ' + (this.accordionItems.length + 1),
            content: 'Custom Object Body - ' + (this.accordionItems.length + 1)
        });
    };
    AccordionDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Accordion.Demo.html"
                },] },
    ];
    /** @nocollapse */
    AccordionDemo.ctorParameters = [];
    return AccordionDemo;
}());
exports.AccordionDemo = AccordionDemo;
//# sourceMappingURL=Accordion.Demo.js.map