"use strict";
var core_1 = require('@angular/core');
var common_1 = require("@angular/common");
var AccordionItem_1 = require("./AccordionItem");
var AccordionHeading_1 = require("./AccordionHeading");
var Accordion = (function () {
    function Accordion() {
        this.closeOthers = true;
        this.duration = 250;
        this.itemEvents = [];
    }
    Accordion.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.items.changes.subscribe(function (i) { return _this.registerItems(); });
        this.registerItems();
    };
    Accordion.prototype.registerItems = function () {
        var _this = this;
        for (var _i = 0, _a = this.itemEvents; _i < _a.length; _i++) {
            var event_1 = _a[_i];
            event_1.unsubscribe();
        }
        var _loop_1 = function(item) {
            item.openChange.subscribe(function () {
                _this.closeOtherItems(item);
            });
        };
        for (var _b = 0, _c = this.items.toArray(); _b < _c.length; _b++) {
            var item = _c[_b];
            _loop_1(item);
        }
    };
    Accordion.prototype.closeOtherItems = function (openItem) {
        if (!this.closeOthers)
            return;
        this.items.forEach(function (item) {
            if (item !== openItem) {
                item.open = false;
            }
        });
    };
    Accordion.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'accordion',
                    template: "<ng-content></ng-content>",
                    styleUrls: ['Accordion.css'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    Accordion.ctorParameters = [];
    Accordion.propDecorators = {
        'closeOthers': [{ type: core_1.Input },],
        'duration': [{ type: core_1.Input },],
        'items': [{ type: core_1.ContentChildren, args: [AccordionItem_1.AccordionItem,] },],
    };
    return Accordion;
}());
exports.Accordion = Accordion;
exports.accordionDirectives = [
    Accordion,
    AccordionItem_1.AccordionItem,
    AccordionHeading_1.AccordionHeading
];
var FuiAccordionModule = (function () {
    function FuiAccordionModule() {
    }
    FuiAccordionModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule],
                    declarations: exports.accordionDirectives,
                    exports: exports.accordionDirectives
                },] },
    ];
    /** @nocollapse */
    FuiAccordionModule.ctorParameters = [];
    return FuiAccordionModule;
}());
exports.FuiAccordionModule = FuiAccordionModule;
//# sourceMappingURL=Accordion.js.map