"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var AlertDemo = (function () {
    function AlertDemo() {
        this.showAlert = false;
        this.closeDelay = 0;
        this.alertType = "success";
        this.alertBody = "<strong>Some alert</strong> success message or something";
        this.attributes = [
            new demoUtilities_1.Attribute('displayed', 'boolean', 'false', 'Two-way binding to display the alert'),
            new demoUtilities_1.Attribute('closeButton', 'boolean', 'true', "Option to display the 'X' in the right hand corner to close the alert"),
            new demoUtilities_1.Attribute('closeDelay', 'number', '0', 'Number in milliseconds until the alert automatically closes. When set to 0, the alert will stay open until manually closed'),
            new demoUtilities_1.Attribute('type', 'string', 'success', 'The type of alert to display. Default types include success, info, warning, and danger. <a href="http://v4-alpha.getbootstrap.com/components/alerts/#link-color" target="_blank">More info here...</a>'),
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
    }
    AlertDemo.prototype.showSuccess = function () {
        this.closeDelay = 0;
        this.alertType = "success";
        this.alertBody = "<strong>Some alert</strong> success message or something";
        this.showAlert = true;
    };
    AlertDemo.prototype.showError = function () {
        this.closeDelay = 0;
        this.alertType = "danger";
        this.alertBody = "<strong>Something went wrong</strong> error message or something";
        this.showAlert = true;
    };
    AlertDemo.prototype.showDelay = function () {
        this.closeDelay = 5000;
        this.alertType = "info";
        this.alertBody = "<strong>Nice!</strong> This will close in 5 seconds...";
        this.showAlert = true;
    };
    AlertDemo.prototype.test = function () {
        console.log("changed");
    };
    AlertDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Alert.Demo.html"
                },] },
    ];
    /** @nocollapse */
    AlertDemo.ctorParameters = [];
    return AlertDemo;
}());
exports.AlertDemo = AlertDemo;
//# sourceMappingURL=Alert.Demo.js.map