"use strict";
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var Alert = (function (_super) {
    __extends(Alert, _super);
    function Alert(_el) {
        _super.call(this);
        this._el = _el;
        this.displayed = false;
        this.closeButton = true;
        this.type = 'success';
        this.closeDelay = 0;
        this.displayedChange = new core_1.EventEmitter();
    }
    Alert.prototype.ngOnChanges = function (event) {
        var _this = this;
        if (this.displayed && this._el.nativeElement.querySelector('.alert')) {
            var classes = this._el.nativeElement.querySelector('.alert').className;
            classes = classes.replace('fuel-ui-alert-fade-out', 'fuel-ui-alert-fade-in');
            this._el.nativeElement.querySelector('.alert').className = classes;
        }
        if (this.closeDelay > 0) {
            setTimeout(function () {
                _this.close();
            }, this.closeDelay);
        }
    };
    Alert.prototype.close = function () {
        var _this = this;
        if (this._el.nativeElement.querySelector('.alert')) {
            var classes = this._el.nativeElement.querySelector('.alert').className;
            classes = classes.replace('fuel-ui-alert-fade-in', 'fuel-ui-alert-fade-out');
            this._el.nativeElement.querySelector('.alert').className = classes;
        }
        setTimeout(function () {
            _this.displayed = false;
            _this.displayedChange.next(null);
        }, 1000);
    };
    Alert.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'alert',
                    templateUrl: 'Alert.html',
                    styleUrls: ['Alert.css'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    Alert.ctorParameters = [
        { type: core_1.ElementRef, },
    ];
    Alert.propDecorators = {
        'displayed': [{ type: core_1.Input },],
        'closeButton': [{ type: core_1.Input },],
        'type': [{ type: core_1.Input },],
        'closeDelay': [{ type: core_1.Input },],
        'displayedChange': [{ type: core_1.Output },],
    };
    return Alert;
}(core_1.OnChanges));
exports.Alert = Alert;
var FuiAlertModule = (function () {
    function FuiAlertModule() {
    }
    FuiAlertModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule],
                    declarations: [Alert],
                    exports: [Alert]
                },] },
    ];
    /** @nocollapse */
    FuiAlertModule.ctorParameters = [];
    return FuiAlertModule;
}());
exports.FuiAlertModule = FuiAlertModule;
//# sourceMappingURL=Alert.js.map