"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var DatePickerDemo = (function () {
    function DatePickerDemo() {
        this.datePickerValue = new Date(2016, 7, 6);
        this.datePickerFieldValue = "8/6/2016";
        this.attributes = [
            new demoUtilities_1.Attribute('minDate', 'string|Date', 'new Date(1900,0,1)', 'Minimum selectable date'),
            new demoUtilities_1.Attribute('maxDate', 'string|Date', 'new Date(2200,0,1)', 'Maximum selectable date'),
            new demoUtilities_1.Attribute('dateFilter', 'function(date): boolean', 'null', 'Filter to disable dates. A return of <i>false</i> will disable the day'),
            new demoUtilities_1.Attribute('value', 'Date', 'null', 'Two-way binding of the selected DateRange')
        ];
        this.dateFieldAttributes = [
            new demoUtilities_1.Attribute('date', 'Date', 'null', 'Two-way binding of the selected date'),
            new demoUtilities_1.Attribute('value', 'string|Date', 'null', 'Two-way binding of the selected date'),
            new demoUtilities_1.Attribute('ngModel', 'string', 'null', 'Two-way binding of the result input string'),
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
    }
    DatePickerDemo.prototype.dateFilter = function (d) {
        if ([2].indexOf(d.getDay()) > -1)
            return false;
        return true;
    };
    DatePickerDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "DatePicker.Demo.html"
                },] },
    ];
    /** @nocollapse */
    DatePickerDemo.ctorParameters = [];
    return DatePickerDemo;
}());
exports.DatePickerDemo = DatePickerDemo;
//# sourceMappingURL=DatePicker.Demo.js.map