"use strict";
var core_1 = require('@angular/core');
var utilities_1 = require('../../utilities');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var DateRangePickerDemo = (function () {
    function DateRangePickerDemo() {
        this.arrivalDate = new Date(2017, 7, 6);
        this.departureDate = new Date(2017, 7, 10);
        this.dateRangePickerValue = new utilities_1.DateRange(this.arrivalDate, this.departureDate);
        this.attributes = [
            new demoUtilities_1.Attribute('minDate', 'string|Date', 'new Date(1900,0,1)', 'Minimum selectable date'),
            new demoUtilities_1.Attribute('maxDate', 'string|Date', 'new Date(2200,0,1)', 'Maximum selectable date'),
            new demoUtilities_1.Attribute('dateFilter', 'function(date): boolean', 'null', 'Filter to disable dates. A return of <i>false</i> will disable the day'),
            new demoUtilities_1.Attribute('value', 'DateRange', 'null', 'Two-way binding of the selected DateRange')
        ];
        this.dateFieldAttributes = [
            new demoUtilities_1.Attribute('date', 'Date', 'null', 'Two-way binding of the selected date'),
            new demoUtilities_1.Attribute('value', 'string|Date', 'null', 'Two-way binding of the selected date'),
            new demoUtilities_1.Attribute('ngModel', 'string', 'null', 'Two-way binding of the result input string'),
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
    }
    //arrivalDate = "8/6/2016";
    //departureDate = "8/10/2016";
    DateRangePickerDemo.prototype.datePickerValueChange = function (event) {
        this.dateRangePickerValue = event;
    };
    DateRangePickerDemo.prototype.dateFilter = function (d) {
        if ([2].indexOf(d.getDay()) > -1)
            return false;
        return true;
    };
    DateRangePickerDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "DateRangePicker.Demo.html"
                },] },
    ];
    /** @nocollapse */
    DateRangePickerDemo.ctorParameters = [];
    return DateRangePickerDemo;
}());
exports.DateRangePickerDemo = DateRangePickerDemo;
//# sourceMappingURL=DateRangePicker.Demo.js.map