"use strict";
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var core_3 = require("@angular/core");
var utilities_1 = require("../../utilities");
var DatePicker_1 = require("./DatePicker");
var DatePickerField_1 = require("./DatePickerField");
var InfiniteScroller_1 = require("../InfiniteScroller/InfiniteScroller");
var StartDateField = (function (_super) {
    __extends(StartDateField, _super);
    function StartDateField(element) {
        _super.call(this);
        this.element = element;
        this._value = "";
        this.readonly = true;
        this.valueChange = new core_2.EventEmitter();
        this.ngModelChange = new core_2.EventEmitter();
        this.dateChange = new core_2.EventEmitter();
        this.select = new core_2.EventEmitter();
    }
    Object.defineProperty(StartDateField.prototype, "value", {
        get: function () { return this._value; },
        set: function (value) {
            if (value == this._value)
                return;
            this._value = value;
            if (value instanceof Date) {
                this._date = value;
            }
            else {
                this._date = utilities_1.DateUtils.handleDateInput(value);
            }
            this.valueChange.next(value);
            this.ngModelChange.next(value);
            this.dateChange.next(this._date);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StartDateField.prototype, "ngModel", {
        set: function (value) {
            this.value = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StartDateField.prototype, "date", {
        get: function () { return this._date; },
        set: function (date) {
            if (!utilities_1.DateUtils.isValidDate(date))
                return;
            if (date.getTime() == this._date.getTime())
                return;
            this._date = date;
            this._value = date.toLocaleDateString();
            this.dateChange.next(date);
            this.ngModelChange.next(this._value);
            this.valueChange.next(this._value);
        },
        enumerable: true,
        configurable: true
    });
    StartDateField.prototype.inputChange = function (value) {
        this.value = value;
    };
    StartDateField.prototype.focused = function (event) {
        this.select.next(event);
    };
    StartDateField.prototype.selected = function (event) {
        this.select.next(event);
    };
    StartDateField.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "[startDateField],.start-date-field",
                },] },
    ];
    /** @nocollapse */
    StartDateField.ctorParameters = [
        { type: core_2.ElementRef, },
    ];
    StartDateField.propDecorators = {
        '_value': [{ type: core_3.HostBinding, args: ["value",] },],
        'readonly': [{ type: core_3.HostBinding, args: ["attr.readonly",] },],
        'value': [{ type: core_3.Input },],
        'valueChange': [{ type: core_3.Output },],
        'ngModel': [{ type: core_3.Input },],
        'ngModelChange': [{ type: core_3.Output },],
        'date': [{ type: core_3.Input },],
        'dateChange': [{ type: core_3.Output },],
        'inputChange': [{ type: core_3.HostListener, args: ["input", ["$event.target.value"],] },],
        'focused': [{ type: core_3.HostListener, args: ["focus", ["$event"],] },],
        'select': [{ type: core_3.Output },],
        'selected': [{ type: core_3.HostListener, args: ["click", ["$event"],] },],
    };
    return StartDateField;
}(DatePickerField_1.DatePickerField));
exports.StartDateField = StartDateField;
var EndDateField = (function (_super) {
    __extends(EndDateField, _super);
    function EndDateField(element) {
        _super.call(this);
        this.element = element;
        this._value = "";
        this.readonly = true;
        this.valueChange = new core_2.EventEmitter();
        this.ngModelChange = new core_2.EventEmitter();
        this.dateChange = new core_2.EventEmitter();
        this.select = new core_2.EventEmitter();
    }
    Object.defineProperty(EndDateField.prototype, "value", {
        get: function () { return this._value; },
        set: function (value) {
            if (value == this._value)
                return;
            this._value = value;
            this._date = utilities_1.DateUtils.handleDateInput(value);
            this.valueChange.next(value);
            this.ngModelChange.next(value);
            this.dateChange.next(this._date);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EndDateField.prototype, "ngModel", {
        set: function (value) {
            this.value = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EndDateField.prototype, "date", {
        get: function () { return this._date; },
        set: function (date) {
            if (!utilities_1.DateUtils.isValidDate(date))
                return;
            if (date.getTime() == this._date.getTime())
                return;
            this._date = date;
            this._value = date.toLocaleDateString();
            this.dateChange.next(date);
            this.ngModelChange.next(this._value);
            this.valueChange.next(this._value);
        },
        enumerable: true,
        configurable: true
    });
    EndDateField.prototype.inputChange = function (value) {
        this.value = value;
    };
    EndDateField.prototype.focused = function (event) {
        this.select.next(event);
    };
    EndDateField.prototype.selected = function (event) {
        this.select.next(event);
    };
    EndDateField.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "[endDateField],.end-date-field",
                },] },
    ];
    /** @nocollapse */
    EndDateField.ctorParameters = [
        { type: core_2.ElementRef, },
    ];
    EndDateField.propDecorators = {
        '_value': [{ type: core_3.HostBinding, args: ["value",] },],
        'readonly': [{ type: core_3.HostBinding, args: ["attr.readonly",] },],
        'value': [{ type: core_3.Input },],
        'valueChange': [{ type: core_3.Output },],
        'ngModel': [{ type: core_3.Input },],
        'ngModelChange': [{ type: core_3.Output },],
        'date': [{ type: core_3.Input },],
        'dateChange': [{ type: core_3.Output },],
        'inputChange': [{ type: core_3.HostListener, args: ["input", ["$event.target.value"],] },],
        'focused': [{ type: core_3.HostListener, args: ["focus", ["$event"],] },],
        'select': [{ type: core_3.Output },],
        'selected': [{ type: core_3.HostListener, args: ["click", ["$event"],] },],
    };
    return EndDateField;
}(DatePickerField_1.DatePickerField));
exports.EndDateField = EndDateField;
var DateRangePicker = (function (_super) {
    __extends(DateRangePicker, _super);
    function DateRangePicker(changeDetector, renderer) {
        _super.call(this, changeDetector, renderer);
        this.valueChange = new core_2.EventEmitter();
        this.calendarDateFilter = function (d) { return true; };
        this._dateTarget = false;
        this.calendarHeight = window.innerWidth <= 480 || window.outerWidth <= 480 ? "auto" : "300px";
        this.startDateChange = new core_2.EventEmitter();
        this.endDateChange = new core_2.EventEmitter();
    }
    Object.defineProperty(DateRangePicker.prototype, "value", {
        set: function (value) {
            this._selectedDate = this.handleRangeInput(value).start;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "minDate", {
        get: function () { return this._minDate; },
        set: function (value) {
            this._minDate = utilities_1.DateUtils.handleDateInput(value);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DateRangePicker.prototype, "maxDate", {
        get: function () { return this._maxDate; },
        set: function (value) {
            this._maxDate = utilities_1.DateUtils.handleDateInput(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "selectedDate", {
        get: function () { return this._selectedDate; },
        set: function (value) {
            this.selectDate(value);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DateRangePicker.prototype, "inputStartDate", {
        get: function () {
            return this.startDateField != null ? this.startDateField.value : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "inputEndDate", {
        get: function () {
            return this.endDateField != null ? this.endDateField.value : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "startDate", {
        get: function () { return this._startDate; },
        set: function (value) {
            if (!utilities_1.DateUtils.isValidDate(value))
                return;
            this._startDate = utilities_1.DateUtils.handleDateInput(value);
            if (this.startDateField != null)
                this.startDateField.value = this._startDate.toLocaleDateString();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "endDate", {
        get: function () { return this._endDate; },
        set: function (value) {
            if (!utilities_1.DateUtils.isValidDate(value))
                return;
            this._endDate = utilities_1.DateUtils.handleDateInput(value);
            if (this.endDateField != null)
                this.endDateField.value = this._endDate.toLocaleDateString();
        },
        enumerable: true,
        configurable: true
    });
    DateRangePicker.prototype.ngAfterContentInit = function () {
        var _this = this;
        if (typeof this.startDateField === "undefined")
            throw "Fuel-UI Error: DateRangePicker missing startDate field";
        var startDateValue = utilities_1.DateUtils.handleDateInput(this.startDateField.value);
        if (this.startDateField.value.length > 0
            && utilities_1.DateUtils.isValidDate(startDateValue))
            this.selectDate(startDateValue, false);
        else {
            this.selectDate(this._startDate, false);
            if (utilities_1.DateUtils.isValidDate(this._startDate))
                this.startDateField._value = this._startDate.toLocaleDateString();
        }
        this.startDateField.select
            .subscribe(function (event) {
            _this.showCalendar(event);
            _this.focusStartDate();
        });
        /* removed due to binding issues in FF
        this.startDateField.dateChange
            .subscribe((date: Date) => {
                if(this.startDate !== date)
                    this.startDate = date;
            });*/
        if (typeof this.endDateField === "undefined")
            throw "Fuel-UI Error: DateRangePicker missing endDate field";
        var endDateValue = utilities_1.DateUtils.handleDateInput(this.endDateField.value);
        if (this.endDateField.value.length > 0
            && utilities_1.DateUtils.isValidDate(endDateValue))
            this.selectDate(endDateValue, true);
        else {
            this.selectDate(this._endDate, true);
            if (utilities_1.DateUtils.isValidDate(this._endDate))
                this.endDateField._value = this._endDate.toLocaleDateString();
        }
        this.endDateField.select
            .subscribe(function (event) {
            _this.showCalendar(event);
            _this.focusEndDate();
        });
        /* removed due to binding issues in FF
        this.endDateField.dateChange
            .subscribe((date: Date) => {
                if(this.endDate !== date)
                    this.endDate = date;
            });*/
        this.dateFieldIcons.map(function (i) {
            i.selectEvent.subscribe(function (event) {
                _this.showCalendar(event);
                if (i.isStartDate())
                    _this.focusStartDate();
                else if (i.isEndDate && _this.inputEndDate.length > 0)
                    _this.focusEndDate();
            });
        });
        this.generateMonths();
    };
    DateRangePicker.prototype.selectDate = function (value, target) {
        var _this = this;
        this._selectedDate = value;
        var dateTarget = (typeof target !== "undefined" && target != null) ? target : this._dateTarget;
        if (!dateTarget) {
            this.startDate = value;
            if (this.startDateChange != null)
                this.startDateChange.next(this._startDate);
            if (utilities_1.DateUtils.isValidDate(this.endDate) && this.startDate > this.endDate)
                this.endDate = new Date(this.startDate.getTime() + 24 * 60 * 60 * 1000);
        }
        else {
            this.endDate = value;
            this.hideCalendar();
            if (this.endDateChange != null)
                this.endDateChange.next(this._endDate);
            if (utilities_1.DateUtils.isValidDate(this.startDate) && this.endDate < this.startDate)
                this.startDate = new Date(this.endDate.getTime() - 24 * 60 * 60 * 1000);
        }
        this._dateTarget = !dateTarget;
        if (this.startDate != null && this.endDate != null) {
            var startDate = new Date(this.startDate.getFullYear(), this.startDate.getMonth(), this.startDate.getDate());
            var endDate = new Date(this.endDate.getFullYear(), this.endDate.getMonth(), this.endDate.getDate());
            this.valueChange.next(new utilities_1.DateRange(startDate, endDate));
        }
        this.calendarDateFilter = function (d) { return _this.dateFilter(d, !_this._dateTarget ? "start" : "end"); };
        this.changeDetector.markForCheck();
    };
    DateRangePicker.prototype.handleRangeInput = function (value) {
        if (!(value instanceof utilities_1.DateRange))
            throw "DateRangePicker error: input is not of type DateRange";
        var range = value;
        this.startDate = range.start;
        this.endDate = range.end;
        return range;
    };
    DateRangePicker.prototype.focusStartDate = function () {
        var _this = this;
        this._dateTarget = false;
        this.calendarDateFilter = function (d) { return _this.dateFilter(d, "start"); };
        //this.changeDetector.markForCheck();
    };
    DateRangePicker.prototype.focusEndDate = function () {
        var _this = this;
        this._dateTarget = true;
        this.calendarDateFilter = function (d) { return _this.dateFilter(d, "end"); };
        //this.changeDetector.markForCheck();
    };
    DateRangePicker.prototype.checkStartDateTarget = function () {
        return !this._dateTarget;
    };
    DateRangePicker.prototype.checkEndDateTarget = function () {
        return this._dateTarget;
    };
    DateRangePicker.decorators = [
        { type: core_1.Component, args: [{
                    selector: "date-range-picker",
                    styleUrls: ["DatePicker.css"],
                    templateUrl: 'DateRangePicker.html',
                    encapsulation: core_1.ViewEncapsulation.None,
                    changeDetection: core_1.ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    DateRangePicker.ctorParameters = [
        { type: core_1.ChangeDetectorRef, },
        { type: core_1.Renderer, },
    ];
    DateRangePicker.propDecorators = {
        'valueChange': [{ type: core_3.Output },],
        'value': [{ type: core_3.Input },],
        'minDate': [{ type: core_3.Input },],
        'maxDate': [{ type: core_3.Input },],
        'dateFilter': [{ type: core_3.Input },],
        'calendarScroller': [{ type: core_2.ViewChild, args: [InfiniteScroller_1.InfiniteScroller,] },],
        'startDateField': [{ type: core_2.ContentChild, args: [StartDateField, { descendants: true },] },],
        'endDateField': [{ type: core_2.ContentChild, args: [EndDateField, { descendants: true },] },],
        'dateFieldIcons': [{ type: core_2.ContentChildren, args: [DatePickerField_1.DatePickerFieldStyler,] },],
        'startDateChange': [{ type: core_3.Output },],
        'startDate': [{ type: core_3.Input },],
        'endDateChange': [{ type: core_3.Output },],
        'endDate': [{ type: core_3.Input },],
    };
    return DateRangePicker;
}(DatePicker_1.DatePicker));
exports.DateRangePicker = DateRangePicker;
//# sourceMappingURL=DateRangePicker.js.map