"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var InfiniteScrollerDemo = (function () {
    function InfiniteScrollerDemo() {
        this.infiniteScrollItems = [];
        this.infiniteScrollMin = 0;
        this.infiniteScrollMax = 1;
        this.markupExample = "&lt;infinite-scroller \n    (next)=&quot;infinteScrollNext()&quot; \n    (prev)=&quot;infiniteScrollPrev()&quot; \n    height=&quot;300px&quot;\n    distance=&quot;120&quot;\n    hideScrollbar=&quot;true&quot;&gt;\n    &lt;div *ngFor=&quot;#item of infiniteScrollItems&quot; \n        class=&quot;card p-a scroll-item&quot;&gt;\n        &lt;div class=&quot;card-block&quot;&gt;\n            &lt;h4 class=&quot;card-title&quot;&gt;Some Item&lt;/h4&gt;\n            &lt;p class=&quot;card-text&quot;&gt;{{item}}&lt;/p&gt;\n        &lt;/div&gt;\n    &lt;/div&gt;\n&lt;/infinite-scroller&gt;";
        this.codeExample = "export class InfiniteScrollerDemo {\n    infiniteScrollItems: string[] = [];\n    infiniteScrollMin: number = 0;\n    infiniteScrollMax: number = 1;\n\n    constructor() {\n        for (let i = 0; i < 10; i++) {\n            this.infinteScrollNext(false);\n        }\n    }\n\n    infiniteScrollPrev(): void {\n        var newItem = \"\";\n        for (let i = 0; i < 50; i++) {\n            newItem += \"Test \" + this.infiniteScrollMin + \" \";\n        }\n\n        this.infiniteScrollMin--;\n        this.infiniteScrollItems.unshift(newItem);\n    }\n\n    infinteScrollNext(clean: boolean = true): void {\n        var newItem = \"\";\n        for (let i = 0; i < 50; i++) {\n            newItem += \"Test \" + this.infiniteScrollMax + \" \";\n        }\n\n        this.infiniteScrollMax++;\n        this.infiniteScrollItems.push(newItem);\n    }\n}";
        this.attributes = [
            new demoUtilities_1.Attribute('height', 'string', 'auto', "Height of element. Examples: '300px', '10%', 'auto', etc."),
            new demoUtilities_1.Attribute('distance', 'number', '100', 'How far up and down the user can scroll for more scroll items'),
            new demoUtilities_1.Attribute('hideScrollbar', 'boolean', 'false', 'Hide the scrollbar of the InfiniteScroller')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('next', 'null', 'When a scroll item is passed when scrolling down'),
            new demoUtilities_1.Event('prev', 'null', 'When a scroll item is passed when scrolling up'),
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
        for (var i = 0; i < 10; i++) {
            this.infinteScrollNext(false);
        }
    }
    InfiniteScrollerDemo.prototype.infiniteScrollPrev = function () {
        var newItem = "";
        for (var i = 0; i < 50; i++) {
            newItem += "Test " + this.infiniteScrollMin + " ";
        }
        this.infiniteScrollMin--;
        this.infiniteScrollItems.unshift(newItem);
    };
    InfiniteScrollerDemo.prototype.infinteScrollNext = function (clean) {
        if (clean === void 0) { clean = true; }
        var newItem = "";
        for (var i = 0; i < 50; i++) {
            newItem += "Test " + this.infiniteScrollMax + " ";
        }
        this.infiniteScrollMax++;
        this.infiniteScrollItems.push(newItem);
    };
    InfiniteScrollerDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "InfiniteScroller.Demo.html"
                },] },
    ];
    /** @nocollapse */
    InfiniteScrollerDemo.ctorParameters = [];
    return InfiniteScrollerDemo;
}());
exports.InfiniteScrollerDemo = InfiniteScrollerDemo;
//# sourceMappingURL=InfiniteScroller.Demo.js.map