"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var ModalDemo = (function () {
    function ModalDemo() {
        this.closeText = "Cancel";
        this.size = "";
        this.attributes = [
            new demoUtilities_1.Attribute('closeOnUnfocus', 'boolean', 'true', 'Closes the opened modal when the user clicks off of it'),
            new demoUtilities_1.Attribute('closeButton', 'boolean', 'true', "Option to display an 'X' close button in the corner of the modal"),
            new demoUtilities_1.Attribute('modalTitle', 'string', 'null', 'Text to display in modal header'),
            new demoUtilities_1.Attribute('size', 'string', 'null', "Change the size of the modal. Supports 'sm' and 'small' for small size and 'lg' and 'large' for large. Null or empty will keep the default size")
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('close', 'null', 'When the modal is closed'),
            new demoUtilities_1.Event('open', 'null', 'When the modal is opened')
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
    }
    ModalDemo.prototype.onClose = function () {
        console.log("Modal has been closed!");
    };
    ModalDemo.prototype.onOpen = function () {
        console.log("Modal has been opened!");
    };
    ModalDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Modal.Demo.html"
                },] },
    ];
    /** @nocollapse */
    ModalDemo.ctorParameters = [];
    return ModalDemo;
}());
exports.ModalDemo = ModalDemo;
exports.MODAL_DEMO_PROVIDERS = [
    ModalDemo
];
//# sourceMappingURL=Modal.Demo.js.map