"use strict";
var core_1 = require('@angular/core');
var common_1 = require("@angular/common");
var Animation_1 = require("../../directives/Animation/Animation");
var Modal = (function () {
    function Modal(el) {
        this.displayed = false;
        this.closeOnUnfocus = true;
        this.closeButton = true;
        this.modalTitle = '';
        this.size = '';
        this.close = new core_1.EventEmitter();
        this.open = new core_1.EventEmitter();
        this._el = el.nativeElement;
    }
    Modal.prototype.clickElement = function (e) {
        if (this.closeOnUnfocus) {
            if ((e.target && (e.target.className == 'modal customFadeIn' || e.target.className == 'modal-dialog'))
                || (e.srcElement && (e.srcElement.className == 'modal customFadeIn' || e.srcElement.className == 'modal-dialog')))
                this.closeModal();
        }
    };
    Modal.prototype.getElement = function () {
        return this._el;
    };
    Modal.prototype.closeModal = function () {
        this.showModal(false);
        this.close.next(null);
        return false;
    };
    Modal.prototype.showModal = function (isDisplayed) {
        var _this = this;
        if (isDisplayed === void 0) { isDisplayed = false; }
        var body = document.body;
        if (isDisplayed === undefined) {
            this.displayed = !this.displayed;
        }
        else {
            this.displayed = isDisplayed;
        }
        if (this.displayed) {
            body.classList.add('modal-open');
            this.open.next(null);
        }
        else {
            body.classList.remove('modal-open');
            if (this.closeOnUnfocus) {
                this._el.childNodes[0].removeEventListener('click', function (e) {
                    if ((e.target && (e.srcElement.className == 'modal customFadeIn' || e.srcElement.className == 'modal-dialog'))
                        || (e.srcElement && (e.srcElement.className == 'modal customFadeIn' || e.srcElement.className == 'modal-dialog')))
                        _this.showModal(false);
                });
            }
        }
        return false;
    };
    Modal.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'modal',
                    host: {
                        '(click)': 'clickElement($event)'
                    },
                    templateUrl: 'Modal.html',
                    styleUrls: ['Modal.css'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    Modal.ctorParameters = [
        { type: core_1.ElementRef, },
    ];
    Modal.propDecorators = {
        'closeOnUnfocus': [{ type: core_1.Input },],
        'closeButton': [{ type: core_1.Input },],
        'modalTitle': [{ type: core_1.Input },],
        'size': [{ type: core_1.Input },],
        'close': [{ type: core_1.Output },],
        'open': [{ type: core_1.Output },],
    };
    return Modal;
}());
exports.Modal = Modal;
var FuiModalModule = (function () {
    function FuiModalModule() {
    }
    FuiModalModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule, Animation_1.FuiAnimationModule],
                    declarations: [Modal],
                    exports: [Modal]
                },] },
    ];
    /** @nocollapse */
    FuiModalModule.ctorParameters = [];
    return FuiModalModule;
}());
exports.FuiModalModule = FuiModalModule;
//# sourceMappingURL=Modal.js.map