"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var OffCanvasMenuDemo = (function () {
    function OffCanvasMenuDemo() {
        this.origin = "left";
        this.width = "25%";
        this.height = "25%";
        this.attributes = [
            new demoUtilities_1.Attribute('origin', '"left" | "top" | "right" "bottom"', '"left"', 'direction the menu extends from'),
            new demoUtilities_1.Attribute('width', 'string', '25% / 100%', 'Width of menu, forced to 100% when menu origin is either top or bottom'),
            new demoUtilities_1.Attribute('height', 'string', '25% / 100%', 'Height of menu, forced to 100% when menu origin is either left or right')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('close', 'null', 'When the menu is closed'),
            new demoUtilities_1.Event('open', 'null', 'When the menu is opened')
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
    }
    OffCanvasMenuDemo.prototype.onClose = function () {
        console.log("Menu has been closed!");
    };
    OffCanvasMenuDemo.prototype.onOpen = function () {
        console.log("Menu has been opened!");
    };
    OffCanvasMenuDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "OffCanvasMenu.Demo.html"
                },] },
    ];
    /** @nocollapse */
    OffCanvasMenuDemo.ctorParameters = [];
    return OffCanvasMenuDemo;
}());
exports.OffCanvasMenuDemo = OffCanvasMenuDemo;
exports.OFFCANVASMENU_DEMO_PROVIDERS = [
    OffCanvasMenuDemo
];
//# sourceMappingURL=OffCanvasMenu.Demo.js.map