"use strict";
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var core_3 = require('@angular/core');
var common_1 = require("@angular/common");
var OffCanvasMenuClose = (function () {
    function OffCanvasMenuClose() {
        this.close = new core_2.EventEmitter();
    }
    OffCanvasMenuClose.prototype.onClick = function (e) {
        this.close.next(null);
    };
    OffCanvasMenuClose.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "[offCanvasMenuClose], .off-canvas-menu-close"
                },] },
    ];
    /** @nocollapse */
    OffCanvasMenuClose.ctorParameters = [];
    OffCanvasMenuClose.propDecorators = {
        'close': [{ type: core_1.Output },],
        'onClick': [{ type: core_2.HostListener, args: ["click", ["$event"],] },],
    };
    return OffCanvasMenuClose;
}());
exports.OffCanvasMenuClose = OffCanvasMenuClose;
var OffCanvasMenu = (function () {
    function OffCanvasMenu() {
        this.origin = "left";
        this.width = "25%";
        this.height = "25%";
        this.close = new core_2.EventEmitter();
        this.open = new core_2.EventEmitter();
        this.computedWidth = this.width;
        this.computedHeight = this.height;
        this.isOpen = false;
        this.overlayState = null;
        this.openState = null;
    }
    OffCanvasMenu.prototype.ngOnInit = function () {
    };
    OffCanvasMenu.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.closeButtons.map(function (b) { return b.close.subscribe(function () { return _this.toggleMenu(); }); });
    };
    OffCanvasMenu.prototype.ngOnDestroy = function () {
    };
    OffCanvasMenu.prototype.toggleMenu = function () {
        this.isOpen = !this.isOpen;
        if (this.isOpen) {
            this.overlayState = "in";
            this.openState = "open";
            this.open.next(null);
        }
        else {
            this.overlayState = null;
            this.openState = null;
            this.close.next(null);
        }
        if (this.origin == "left" || this.origin == "right") {
            this.computedHeight = "100%";
            this.computedWidth = this.width;
        }
        else if (this.origin == "top" || this.origin == "bottom") {
            this.computedWidth = "100%";
            this.computedHeight = this.height;
        }
    };
    OffCanvasMenu.decorators = [
        { type: core_1.Component, args: [{
                    selector: "off-canvas-menu",
                    templateUrl: "OffCanvasMenu.html",
                    styleUrls: ["OffCanvasMenu.css"],
                    encapsulation: core_1.ViewEncapsulation.None,
                    animations: [
                        core_3.trigger("open", [
                            core_3.state("open", core_3.style({ transform: "translate(0,0)" })),
                            core_3.transition("void => open", [core_3.animate("200ms ease")]),
                            core_3.transition("open => void", [core_3.animate("200ms ease")])
                        ]),
                        core_3.trigger("fade", [
                            core_3.state("in", core_3.style({ opacity: ".75" })),
                            core_3.transition("void => in", [core_3.animate("200ms ease")]),
                            core_3.transition("in => void", [core_3.animate("200ms ease")])
                        ])
                    ]
                },] },
    ];
    /** @nocollapse */
    OffCanvasMenu.ctorParameters = [];
    OffCanvasMenu.propDecorators = {
        'origin': [{ type: core_1.Input },],
        'width': [{ type: core_1.Input },],
        'height': [{ type: core_1.Input },],
        'close': [{ type: core_1.Output },],
        'open': [{ type: core_1.Output },],
        'closeButtons': [{ type: core_1.ContentChildren, args: [OffCanvasMenuClose,] },],
    };
    return OffCanvasMenu;
}());
exports.OffCanvasMenu = OffCanvasMenu;
exports.offCanvasMenuDirectives = [
    OffCanvasMenu,
    OffCanvasMenuClose
];
var FuiOffCanvasMenuModule = (function () {
    function FuiOffCanvasMenuModule() {
    }
    FuiOffCanvasMenuModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule],
                    declarations: exports.offCanvasMenuDirectives,
                    exports: exports.offCanvasMenuDirectives
                },] },
    ];
    /** @nocollapse */
    FuiOffCanvasMenuModule.ctorParameters = [];
    return FuiOffCanvasMenuModule;
}());
exports.FuiOffCanvasMenuModule = FuiOffCanvasMenuModule;
//# sourceMappingURL=OffCanvasMenu.js.map