"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var PaginationDemo = (function () {
    function PaginationDemo() {
        this.totalPages = 10;
        this.pagesAtOnce = 5;
        this.currentPage = 1;
        this.showSteps = true;
        this.showEnds = true;
        this.showSelect = true;
        this.attributes = [
            new demoUtilities_1.Attribute('currentPage', 'number', '1', 'Currently active page'),
            new demoUtilities_1.Attribute('pagesAtOnce', 'number', '5', 'The max number of pages to be displayed at once'),
            new demoUtilities_1.Attribute('totalPages', 'number', '10', 'Total number of pages'),
            new demoUtilities_1.Attribute('showSelect', 'boolean', 'true', 'Show jump to select to choose page number from select box'),
            new demoUtilities_1.Attribute('showEnds', 'boolean', 'true', 'Show first/last buttons to jump to the first or last page'),
            new demoUtilities_1.Attribute('showSteps', 'boolean', 'true', 'Show arrows on ends of page numbers to step through pages')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('currentPageChange', '$event = newCurrentPage: number', 'New active page number')
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
    }
    PaginationDemo.prototype.pageChange = function (page) {
        this.currentPage = page;
    };
    PaginationDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Pagination.Demo.html"
                },] },
    ];
    /** @nocollapse */
    PaginationDemo.ctorParameters = [];
    return PaginationDemo;
}());
exports.PaginationDemo = PaginationDemo;
exports.PAGINATION_DEMO_PROVIDERS = [
    PaginationDemo
];
//# sourceMappingURL=Pagination.Demo.js.map