"use strict";
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var Range_1 = require("../../pipes/Range/Range");
var Pagination = (function () {
    function Pagination() {
        this.currentPage = 1;
        this.pagesAtOnce = 5;
        this.totalPages = 10;
        this.showSteps = true;
        this.showEnds = true;
        this.showSelect = true;
        this.currentPageChange = new core_1.EventEmitter();
        this.pagesBlank = [];
        this.setPage(this.currentPage);
    }
    Pagination.prototype.ngOnChanges = function (changes) {
        this.setPage(this.currentPage);
    };
    Pagination.prototype.setPage = function (newPage) {
        if (newPage < 1 || newPage > this.totalPages)
            return;
        this.currentPage = newPage;
        //Shift pagination stuffs
        if (this.currentPage - Math.ceil(this.pagesAtOnce / 2) < 0 || this.totalPages - this.pagesAtOnce <= 0) {
            this.startingIndex = 0;
            this.endingIndex = this.pagesAtOnce;
        }
        else if (this.totalPages - this.currentPage <= this.pagesAtOnce - Math.ceil(this.pagesAtOnce / 2)) {
            this.startingIndex = this.totalPages - this.pagesAtOnce;
            this.endingIndex = this.totalPages;
        }
        else {
            this.startingIndex = this.currentPage - Math.ceil(this.pagesAtOnce / 2);
            this.endingIndex = this.startingIndex + this.pagesAtOnce < this.totalPages
                ? this.startingIndex + this.pagesAtOnce
                : this.totalPages;
        }
        this.currentPageChange.next(this.currentPage);
    };
    Pagination.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'pagination',
                    changeDetection: core_1.ChangeDetectionStrategy.OnPush,
                    templateUrl: 'Pagination.html',
                    styleUrls: ['Pagination.css'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    Pagination.ctorParameters = [];
    Pagination.propDecorators = {
        'currentPage': [{ type: core_1.Input },],
        'pagesAtOnce': [{ type: core_1.Input },],
        'totalPages': [{ type: core_1.Input },],
        'showSteps': [{ type: core_1.Input },],
        'showEnds': [{ type: core_1.Input },],
        'showSelect': [{ type: core_1.Input },],
        'currentPageChange': [{ type: core_1.Output },],
    };
    return Pagination;
}());
exports.Pagination = Pagination;
var FuiPaginationModule = (function () {
    function FuiPaginationModule() {
    }
    FuiPaginationModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule, Range_1.FuiRangePipeModule],
                    declarations: [Pagination],
                    exports: [Pagination]
                },] },
    ];
    /** @nocollapse */
    FuiPaginationModule.ctorParameters = [];
    return FuiPaginationModule;
}());
exports.FuiPaginationModule = FuiPaginationModule;
//# sourceMappingURL=Pagination.js.map