"use strict";
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var TabSet_1 = require("./TabSet");
var Tab = (function () {
    function Tab(tabset) {
        this.activeChange = new core_1.EventEmitter(false);
        this.select = new core_1.EventEmitter(false);
        this.deselect = new core_1.EventEmitter(false);
        this.remove = new core_1.EventEmitter(false);
        this.addClass = true;
        this.tabset = tabset;
        this.tabset.addTab(this);
    }
    Object.defineProperty(Tab.prototype, "active", {
        /** tab active state toggle */
        get: function () {
            return this._active;
        },
        set: function (active) {
            var _this = this;
            if (this.disabled && active || !active) {
                //Only emit deselect event when changing
                if (this._active && this._active != active) {
                    this.deselect.next(this);
                }
                if (!active) {
                    this._active = active;
                }
                this.activeChange.next(this._active);
                return;
            }
            //Only emit select event when changing
            if (this._active != active) {
                this.select.next(this);
            }
            this._active = active;
            this.activeChange.next(this._active);
            this.tabset.tabs.forEach(function (tab) {
                if (tab !== _this) {
                    tab.active = false;
                    tab.activeChange.next(false);
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    Tab.prototype.ngOnDestroy = function () {
        this.tabset.removeTab(this);
    };
    Tab.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'tab, [tab]'
                },] },
    ];
    /** @nocollapse */
    Tab.ctorParameters = [
        { type: TabSet_1.TabSet, },
    ];
    Tab.propDecorators = {
        'heading': [{ type: core_1.Input },],
        'disabled': [{ type: core_1.Input },],
        'removable': [{ type: core_1.Input },],
        'active': [{ type: core_1.HostBinding, args: ['class.active',] }, { type: core_1.Input },],
        'activeChange': [{ type: core_1.Output },],
        'select': [{ type: core_1.Output },],
        'deselect': [{ type: core_1.Output },],
        'remove': [{ type: core_1.Output },],
        'addClass': [{ type: core_1.HostBinding, args: ['class.tab-pane',] },],
    };
    return Tab;
}());
exports.Tab = Tab;
exports.tabDirectives = [
    Tab,
    TabSet_1.TabSet
];
var FuiTabModule = (function () {
    function FuiTabModule() {
    }
    FuiTabModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule],
                    declarations: exports.tabDirectives,
                    exports: exports.tabDirectives
                },] },
    ];
    /** @nocollapse */
    FuiTabModule.ctorParameters = [];
    return FuiTabModule;
}());
exports.FuiTabModule = FuiTabModule;
//# sourceMappingURL=Tab.js.map