"use strict";
var core_1 = require('@angular/core');
var TableSortable_1 = require('./TableSortable');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var TableSortableDemo = (function () {
    function TableSortableDemo() {
        this.codeExample1 = "&lt;table-sortable\n    [columns]=&quot;columns&quot;\n\t[data]=&quot;rows&quot;\n\t[sort]=&quot;sorting&quot;&gt;\n  Loading table...\n&lt;/table-sortable&gt;";
        this.codeExample2 = "export class TableSortableExample {\n    rows: any[] = [\n    {\n      Name: 'Data 1',\n      Amount: 100.23,\n      Date: 1441588216000,\n      Desc: \"You can't sort\"\n    },\n    {\n      Name: 'Data 2',\n      Amount: 0.875623,\n      Date: 1442387616000,\n      Desc: \"On this\"\n    },\n    {\n      Name: 'Data 3',\n      Amount: .010123,\n      Date: 1442187616000,\n      Desc: \"Table column\"\n    }\n  ];\n  columns: TableSortableColumn[] = [\n    {\n      display: 'Column 1', //The text to display\n      variable: 'Name', //The name of the key that's apart of the data array\n      filter: 'text', //The type data type of the column (number, text, date, etc.)\n      sortable: true //Whether the user can sort on the column\n    },\n    new TableSortableColumn('Column 2', 'Amount', 'decimal : 1.0-2'),\n    new TableSortableColumn('Column 3', 'Date', 'dateTime'),\n    new TableSortableColumn('Column 4', 'Desc', 'text', false)\n  ];\n  sorting: TableSortableSorting = {\n    column: 'Name', //to match the variable of one of the columns\n    descending: false\n  };\n}";
        this.rows = [
            {
                Name: 'Data 1',
                Amount: 100.23,
                Date: 1441588216000,
                Desc: "You can't sort"
            },
            {
                Name: 'Data 2',
                Amount: 0.875623,
                Date: 1442387616000,
                Desc: "On this"
            },
            {
                Name: 'Data 3',
                Amount: .010123,
                Date: 1442187616000,
                Desc: "Table column"
            }
        ];
        this.columns = [
            {
                display: 'Column 1',
                variable: 'Name',
                filter: 'text',
                sortable: true //Whether the user can sort on the column
            },
            new TableSortable_1.TableSortableColumn('Column 2', 'Amount', 'decimal : 1.0-2'),
            new TableSortable_1.TableSortableColumn('Column 3', 'Date', 'dateTime'),
            new TableSortable_1.TableSortableColumn('Column 4', 'Desc', 'text', false)
        ];
        this.sorting = {
            column: 'Name',
            descending: false
        };
        this.attributes = [
            new demoUtilities_1.Attribute('columns', 'TableSortableColumn[]', 'null', 'Array of all columns to be displayed and how to format them for ordering'),
            new demoUtilities_1.Attribute('data', 'any[]', 'null', 'Any arbitrary array of objects'),
            new demoUtilities_1.Attribute('sort', 'TableSortableSorting', 'null', 'Which column to sort on and which direction (ascending or descending)')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
    }
    TableSortableDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "TableSortable.Demo.html"
                },] },
    ];
    /** @nocollapse */
    TableSortableDemo.ctorParameters = [];
    return TableSortableDemo;
}());
exports.TableSortableDemo = TableSortableDemo;
//# sourceMappingURL=TableSortable.Demo.js.map