"use strict";
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var OrderBy_1 = require("../../pipes/OrderBy/OrderBy");
var Format_1 = require("../../pipes/Format/Format");
var TableSortable = (function () {
    function TableSortable() {
    }
    TableSortable.prototype.selectedClass = function (column) {
        if (!column.sortable)
            return 'fuel-ui-not-sortable';
        return column.variable == this.sort.column ? 'sort-' + (this.sort.descending ? 'desc' : 'asc') : '';
    };
    TableSortable.prototype.changeSorting = function (column) {
        if (!column.sortable)
            return;
        var sort = this.sort;
        if (sort.column == column.variable) {
            sort.descending = !sort.descending;
        }
        else {
            sort.column = column.variable;
            sort.descending = false;
        }
    };
    TableSortable.prototype.convertSorting = function () {
        return this.sort.descending ? '-' + this.sort.column : this.sort.column;
    };
    TableSortable.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'table-sortable',
                    templateUrl: 'TableSortable.html',
                    styleUrls: ['TableSortable.css'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    TableSortable.ctorParameters = [];
    TableSortable.propDecorators = {
        'columns': [{ type: core_1.Input },],
        'data': [{ type: core_1.Input },],
        'sort': [{ type: core_1.Input },],
    };
    return TableSortable;
}());
exports.TableSortable = TableSortable;
var TableSortableColumn_1 = require("./TableSortableColumn");
exports.TableSortableColumn = TableSortableColumn_1.TableSortableColumn;
var TableSortableSorting_1 = require("./TableSortableSorting");
exports.TableSortableSorting = TableSortableSorting_1.TableSortableSorting;
var FuiTableSortableModule = (function () {
    function FuiTableSortableModule() {
    }
    FuiTableSortableModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule, forms_1.FormsModule, Format_1.FuiFormatPipeModule, OrderBy_1.FuiOrderByPipeModule],
                    declarations: [TableSortable],
                    exports: [TableSortable]
                },] },
    ];
    /** @nocollapse */
    FuiTableSortableModule.ctorParameters = [];
    return FuiTableSortableModule;
}());
exports.FuiTableSortableModule = FuiTableSortableModule;
//# sourceMappingURL=TableSortable.js.map