"use strict";
var core_1 = require('@angular/core');
var common_1 = require("@angular/common");
var TagSet_1 = require('./TagSet');
var Tag = (function () {
    function Tag(tagset) {
        this.removable = false;
        this.remove = new core_1.EventEmitter(false);
        this.classMap = {};
        this.tagset = tagset;
        this.tagset.addTag(this);
    }
    Object.defineProperty(Tag.prototype, "pill", {
        get: function () { return this._pill; },
        set: function (value) {
            this._pill = value;
            this.setClassMap();
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(Tag.prototype, "color", {
        get: function () { return this._color; },
        set: function (value) {
            this._color = value;
            this.setClassMap();
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(Tag.prototype, "disabled", {
        get: function () { return this._disabled; },
        set: function (value) {
            this._disabled = value;
            this.setClassMap();
        },
        enumerable: true,
        configurable: true
    });
    ;
    Tag.prototype.ngOnInit = function () {
        this.color = this.color !== 'undefined' ? this.color : 'default';
    };
    Tag.prototype.ngOnDestroy = function () {
        this.remove.next(this);
        this.tagset.removeTag(this);
    };
    Tag.prototype.setClassMap = function () {
        this.classMap = (_a = {
                'disabled': this.disabled,
                'tag-pill': this.pill
            },
            _a['tag-' + ((this.color && this.color.toLowerCase()) || 'default')] = true,
            _a
        );
        var _a;
    };
    Tag.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'tag, [tag]'
                },] },
    ];
    /** @nocollapse */
    Tag.ctorParameters = [
        { type: TagSet_1.TagSet, },
    ];
    Tag.propDecorators = {
        'title': [{ type: core_1.Input },],
        'value': [{ type: core_1.Input },],
        'removable': [{ type: core_1.Input },],
        'pill': [{ type: core_1.Input },],
        'color': [{ type: core_1.Input },],
        'disabled': [{ type: core_1.Input },],
        'remove': [{ type: core_1.Output },],
    };
    return Tag;
}());
exports.Tag = Tag;
exports.tagDirectives = [
    Tag,
    TagSet_1.TagSet
];
var FuiTagModule = (function () {
    function FuiTagModule() {
    }
    FuiTagModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [common_1.CommonModule],
                    declarations: exports.tagDirectives,
                    exports: exports.tagDirectives
                },] },
    ];
    /** @nocollapse */
    FuiTagModule.ctorParameters = [];
    return FuiTagModule;
}());
exports.FuiTagModule = FuiTagModule;
//# sourceMappingURL=Tag.js.map