"use strict";
var core_1 = require('@angular/core');
var TagSet = (function () {
    function TagSet() {
        this.tags = [];
    }
    TagSet.prototype.ngOnDestroy = function () {
        this.destroyed = true;
    };
    TagSet.prototype.addTag = function (tag) {
        this.tags.push(tag);
    };
    TagSet.prototype.removeTag = function (tag) {
        var index = this.tags.indexOf(tag);
        if (index === -1 || this.destroyed || tag.disabled) {
            return;
        }
        tag.remove.next(tag);
        this.tags.splice(index, 1);
    };
    TagSet.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'tagset',
                    templateUrl: 'TagSet.html',
                    styleUrls: ['Tag.css'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    TagSet.ctorParameters = [];
    TagSet.propDecorators = {
        'tags': [{ type: core_1.Input },],
    };
    return TagSet;
}());
exports.TagSet = TagSet;
//# sourceMappingURL=TagSet.js.map