"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var TextExpanderDemo = (function () {
    function TextExpanderDemo() {
        this.expanded = false;
        this.ellipsis = true;
        this.text = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed massa sed odio gravida iaculis. Sed elementum dapibus neque, sit.";
        this.characters = 50;
        this.words = 0;
        this.expandText = "Show more";
        this.shrinkText = "Show less";
        this.attributes = [
            new demoUtilities_1.Attribute('expanded', 'boolean', 'false', 'The current state of whether or not the complete text is displayed'),
            new demoUtilities_1.Attribute('ellipsis', 'boolean', 'true', 'Add "..." at the end of the text when not expanded'),
            new demoUtilities_1.Attribute('text', 'string', 'null', 'The text that can be expanded/shrunk'),
            new demoUtilities_1.Attribute('characters', 'number', '50', 'The number of characters displayed when text is shrunk'),
            new demoUtilities_1.Attribute('words', 'number', '0', 'The number of words displayed when text is shrunk. If set to 0, characters are defaulted to'),
            new demoUtilities_1.Attribute('expandText', 'string', 'show more', 'Clickable text used to expand text'),
            new demoUtilities_1.Attribute('shrinkText', 'string', 'show less', 'Clickable text used to shrink text')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('expandedChange', '$event = expanded: boolean', 'New state of whether the text is expanded or not')
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
    }
    TextExpanderDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "TextExpander.Demo.html"
                },] },
    ];
    /** @nocollapse */
    TextExpanderDemo.ctorParameters = [];
    return TextExpanderDemo;
}());
exports.TextExpanderDemo = TextExpanderDemo;
//# sourceMappingURL=TextExpander.Demo.js.map