"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var TimePickerDemo = (function () {
    function TimePickerDemo() {
        this.date = new Date();
        this.minDate = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 0, 0, 0);
        this.maxDate = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 23, 59, 59);
        this.hourStep = 1;
        this.minuteStep = 1;
        this.readonly = false;
        this.disabled = false;
        this.showSeconds = true;
        this.showSpinners = true;
        this.showMeridian = true;
        this.timepickerAttributes = [
            new demoUtilities_1.Attribute('hourStep', 'number', '1', 'The amount of hours per step'),
            new demoUtilities_1.Attribute('minuteStep', 'number', '1', 'The amount of minutes per step'),
            new demoUtilities_1.Attribute('secondStep', 'number', '1', 'The amount of seconds per step'),
            new demoUtilities_1.Attribute('value', 'Date', 'new Date(new Date().getFullYear(), 0, 1, 0, 0, 0)', 'Date value of the TimePicker'),
            new demoUtilities_1.Attribute('meridians', 'string[]', '["AM", "PM"]', 'An array of 2 strings to be used for the 2 meridians'),
            new demoUtilities_1.Attribute('showSeconds', 'boolean', 'false', 'Show the seconds input to update'),
            new demoUtilities_1.Attribute('readonlyInput', 'boolean', 'false', 'Make inputs that are shown readonly'),
            new demoUtilities_1.Attribute('showSpinners', 'boolean', 'true', 'Show or hide arrows to click and step through inputs'),
            new demoUtilities_1.Attribute('disabled', 'boolean', 'false', 'Disable all showing inputs, buttons, and spinners'),
            new demoUtilities_1.Attribute('min', 'Date', 'new Date(new Date().getFullYear(), 0, 1, 0, 0, 0)', 'Miniumum selectable date'),
            new demoUtilities_1.Attribute('max', 'Date', 'new Date(new Date().getFullYear(), 0, 1, 23, 59, 59)', 'Maximum selectable date')
        ];
        this.timepickerAttributesColumns = demoUtilities_1.AttributeColumns;
        this.timepickerAttributesSort = demoUtilities_1.AttributesDefaultSort;
        this.timepickerEvents = [
            new demoUtilities_1.Event('value', '$event = date: Date', 'Curently selected date of TimePicker')
        ];
        this.timepickerEventsColumns = demoUtilities_1.EventColumns;
        this.timepickerEventsSort = demoUtilities_1.EventsDefaultSort;
    }
    TimePickerDemo.prototype.setDate = function () {
        this.date = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 14, 0, 0);
    };
    TimePickerDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "TimePicker.Demo.html"
                },] },
    ];
    /** @nocollapse */
    TimePickerDemo.ctorParameters = [];
    return TimePickerDemo;
}());
exports.TimePickerDemo = TimePickerDemo;
exports.TIMEPICKER_DEMO_PROVIDERS = [
    TimePickerDemo
];
//# sourceMappingURL=TimePicker.Demo.js.map