"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var AnimationDemo = (function () {
    function AnimationDemo() {
        this.codeExample1 = "&lt;div class=&quot;some-animation-class&quot;\n    animation=&quot;test-animation-a&quot;\n    [play]=&quot;play&quot;\n    (animationstart)=&quot;logStart($event)&quot;\n    (animationend)=&quot;logEnd($event)&quot;&gt;&lt;/div&gt;\n&lt;button class=&quot;btn btn-primary&quot; (click)=&quot;start()&quot;&gt;Play&lt;/button&gt;";
        this.codeExample2 = "export class AnimationExample {\n    play:boolean = false;\n    animationLog:any[] = [];\n    \n    start(): void{\n        this.play = true;\n    }\n    \n    logStart($event: any): void {\n        this.animationLog.push($event);\n    }\n\n    logEnd($event: any): void {\n        this.play = false;\n        this.animationLog.push($event);\n    }\n}";
        this.play = false;
        this.animationLog = [];
        this.attributes = [
            new demoUtilities_1.Attribute('play', 'boolean', 'false', 'Start the animation')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('animationstart', 'Animation Object', 'Information about the animation when it starts'),
            new demoUtilities_1.Event('animationend', 'Animation Object', 'Information about the animation when it ends')
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
    }
    AnimationDemo.prototype.start = function () {
        this.play = true;
    };
    AnimationDemo.prototype.logStart = function ($event) {
        $event.time = new Date().getTime();
        this.animationLog.push($event);
    };
    AnimationDemo.prototype.logEnd = function ($event) {
        this.play = false;
        $event.time = new Date().getTime();
        this.animationLog.push($event);
    };
    AnimationDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Animation.Demo.html"
                },] },
    ];
    /** @nocollapse */
    AnimationDemo.ctorParameters = [];
    return AnimationDemo;
}());
exports.AnimationDemo = AnimationDemo;
//# sourceMappingURL=Animation.Demo.js.map