"use strict";
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var TooltipDemo = (function () {
    function TooltipDemo() {
        this.codeExample1 = "&lt;a href=&quot;#&quot; tooltip text=&quot;Tooltip text goes here.&quot;\n    [position]=&quot;position&quot; [color]=&quot;color&quot; [size]=&quot;size&quot;\n    [rounded]=&quot;rounded&quot; [always]=&quot;always&quot;&gt;\n    Some text here.\n&lt;/a&gt;\n\n&lt;div class=&quot;col-md-4 form-group&quot;&gt;\n    &lt;div tooltip text=&quot;You have entered: {{tooltipText}}!&quot;\n                [position]=&quot;position&quot; [color]=&quot;color&quot; [size]=&quot;size&quot;\n                [rounded]=&quot;rounded&quot; [always]=&quot;always&quot;&gt;\n        &lt;input [(ngModel)]=&quot;tooltipText&quot; type=&quot;text&quot; class=&quot;form-control&quot; placeholder=&quot;Tooltip text&quot; /&gt;\n    &lt;/div&gt;\n    &lt;small class=&quot;text-muted&quot;&gt;Enter text above, then hover the input.&lt;/small&gt;\n&lt;/div&gt;";
        this.attributes = [
            new demoUtilities_1.Attribute('text', 'string', 'null', 'Text of the tooltip'),
            new demoUtilities_1.Attribute('position', 'string', 'top', "Position of the tooltip compared to the element. Allows for: 'bottom-right', 'bottom', 'bottom-left', 'right', 'left', 'top-right,' 'top', or 'top-left'"),
            new demoUtilities_1.Attribute('color', 'string', 'none', "Color of tooltip. Allows for: 'error', 'info', 'success', and 'warning'. Using anything else, include 'none', will result in the default black background with white text"),
            new demoUtilities_1.Attribute('rounded', 'boolean', 'false', 'Rounded edges of tooltip'),
            new demoUtilities_1.Attribute('always', 'boolean', 'false', 'Tooltip always displays even on mouseout and unfocus'),
            new demoUtilities_1.Attribute('size', 'string', 'auto', "Forced size of the tooltip. Allows for: 'small', 'medium', and 'large'. Anything else will cause the tooltip to shrink to fit, and stay on a single line."),
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.position = "top";
        this.color = "none";
        this.size = "auto";
        this.tooltipText = "";
        this.rounded = false;
        this.always = false;
    }
    TooltipDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Tooltip.Demo.html"
                },] },
    ];
    /** @nocollapse */
    TooltipDemo.ctorParameters = [];
    return TooltipDemo;
}());
exports.TooltipDemo = TooltipDemo;
//# sourceMappingURL=Tooltip.Demo.js.map