"use strict";
var core_1 = require('@angular/core');
var TableSortable_1 = require('../../components/TableSortable/TableSortable');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var DataType = (function () {
    function DataType(Type, Parameters, Input, Output) {
        this.Type = Type;
        this.Parameters = Parameters;
        this.Input = Input;
        this.Output = Output;
    }
    return DataType;
}());
exports.DataType = DataType;
var FormatDemo = (function () {
    function FormatDemo() {
        this.htmlCodeExample = "&lt;span&gt;{{someVar | format : \"number : 1.0-2\"}}&lt;/span&gt;\n&lt;span&gt;{{someTimestamp | format : \"dateTime : MMM d, y h:mm:ss a\"}}&lt;/span&gt;";
        this.someNumberVar = '435.23528';
        this.someTimestamp = 1442187616000;
        this.parameters = [
            new demoUtilities_1.Attribute('Name', 'string', 'text', 'The type of data you want the input to be output as'),
        ];
        this.parametersColumns = demoUtilities_1.AttributeColumns;
        this.parametersSort = demoUtilities_1.AttributesDefaultSort;
        this.dataTypes = [
            new DataType('date', "true - format of date - default: 'MMM d, y h:mm:ss a'", '"1442187616000"', 'Sep 13, 2015, 7:40:16 PM'),
            new DataType('datetime', "true - format of date - default: 'MMM d, y h:mm:ss a'", '"1442187616000"', 'Sep 13, 2015, 7:40:16 PM'),
            new DataType('decimal', "true - number formatting - default: '1.0-0'", '"1442187616000"', '1442187616000'),
            new DataType('html', 'false', '"&lt;a href=&quot;http://fueltravel.com&quot; target=&quot;_blank&quot;&gt;Fuel Travel&lt;/a&gt;"', '<a href="http://fueltravel.com" target="_blank">Fuel Travel</a>'),
            new DataType('number', "true - number formatting - default: '1.0-0'", '"1442187616000"', '1442187616000'),
            new DataType('percentage', "true - number formatting - default: '1.0-0'", '"1442187616000"', '"1442187616000%"'),
            new DataType('text', 'false', '"&lt;a href=&quot;http://fueltravel.com&quot; target=&quot;_blank&quot;&gt;Fuel Travel&lt;/a&gt;"', '"&lt;a href=&quot;http://fueltravel.com&quot; target=&quot;_blank&quot;&gt;Fuel Travel&lt;/a&gt;"')
        ];
        this.dataTypesColumns = [
            new TableSortable_1.TableSortableColumn('Type', 'Type', 'string'),
            new TableSortable_1.TableSortableColumn('Parameters?', 'Parameters', 'html'),
            new TableSortable_1.TableSortableColumn('Input', 'Input', 'html'),
            new TableSortable_1.TableSortableColumn('Output', 'Output', 'html'),
        ];
        this.dataTypesSort = new TableSortable_1.TableSortableSorting('Type', false);
    }
    FormatDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "Format.Demo.html"
                },] },
    ];
    /** @nocollapse */
    FormatDemo.ctorParameters = [];
    return FormatDemo;
}());
exports.FormatDemo = FormatDemo;
//# sourceMappingURL=Format.Demo.js.map