"use strict";
var core_1 = require('@angular/core');
var Person = (function () {
    function Person(firstName, lastName, age) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.info = new PersonInfo(age);
    }
    return Person;
}());
exports.Person = Person;
var PersonInfo = (function () {
    function PersonInfo(age) {
        this.age = age;
    }
    return PersonInfo;
}());
exports.PersonInfo = PersonInfo;
var OrderByDemo = (function () {
    function OrderByDemo() {
        this.typescriptCodeExample = "export class Person {\n    public firstName: string;\n    public lastName: string;\n    public info: PersonInfo;\n\n    constructor(firstName: string, lastName: string, age: number) {\n        this.firstName = firstName;\n        this.lastName = lastName;\n        this.info = new PersonInfo(age);\n    }\n}\n\nexport class PersonInfo {\n    constructor(public age: number){}\n}\n\nexport class OrderByExample {\n    people: Person[] = [\n        new Person('Linus', 'Torvalds', 46),\n        new Person('Larry', 'Ellison', 71),\n        new Person('Mark', 'Zuckerberg', 31),\n        new Person('Sergey', 'Brin', 42),\n        new Person('Vint', 'Cerf', 72),\n        new Person('Richard', 'Stallman', 62),\n        new Person('John', 'Papa', 42)\n    ];\n}";
        this.newPerson = new Person('', '', 18);
        this.people = [
            new Person('Linus', 'Torvalds', 46),
            new Person('Larry', 'Ellison', 71),
            new Person('Mark', 'Zuckerberg', 31),
            new Person('Sergey', 'Brin', 42),
            new Person('Vint', 'Cerf', 72),
            new Person('Richard', 'Stallman', 62),
            new Person('John', 'Papa', 42)
        ];
        this.peopleOrderBy1Desc = "-";
        this.peopleOrderBy1Property = "info.age";
        this.peopleOrderBy2Desc = "";
        this.peopleOrderBy2Property = "firstName";
        this.peopleOrderByConfig = [
            (this.peopleOrderBy1Desc + this.peopleOrderBy1Property),
            (this.peopleOrderBy2Desc + this.peopleOrderBy2Property)
        ];
        this.newFruit = "";
        this.fruit = ["orange", "apple", "pear", "grape", "banana"];
        this.fruitOrderByConfig = "+";
    }
    OrderByDemo.prototype.addToArrays = function () {
        this.fruit.push("new fruit");
        this.people.push(new Person('New', 'Person', 47));
    };
    OrderByDemo.prototype.setFruitConfig = function (newConfig) {
        this.fruitOrderByConfig = newConfig;
    };
    OrderByDemo.prototype.addFruit = function () {
        if (this.newFruit.length <= 0)
            return;
        this.fruit.push(this.newFruit);
        this.newFruit = '';
    };
    OrderByDemo.prototype.setPeopleConfig = function (type, index, newConfig) {
        if (type == "desc") {
            if (index == 1) {
                this.peopleOrderBy1Desc = newConfig;
            }
            else {
                this.peopleOrderBy2Desc = newConfig;
            }
        }
        else {
            if (index == 1) {
                this.peopleOrderBy1Property = newConfig;
            }
            else {
                this.peopleOrderBy2Property = newConfig;
            }
        }
        this.peopleOrderByConfig = [
            (this.peopleOrderBy1Desc + this.peopleOrderBy1Property),
            (this.peopleOrderBy2Desc + this.peopleOrderBy2Property)
        ];
    };
    OrderByDemo.prototype.addPerson = function () {
        if (this.newPerson.firstName.length <= 0 ||
            this.newPerson.lastName.length <= 0 ||
            this.newPerson.info.age <= 0)
            return;
        this.people.push(this.newPerson);
        this.newPerson = new Person('', '', 18);
    };
    OrderByDemo.decorators = [
        { type: core_1.Component, args: [{
                    templateUrl: "OrderBy.Demo.html"
                },] },
    ];
    /** @nocollapse */
    OrderByDemo.ctorParameters = [];
    return OrderByDemo;
}());
exports.OrderByDemo = OrderByDemo;
//# sourceMappingURL=OrderBy.Demo.js.map